package zxingbarcodescannerwrapper;

import main.java.me.dm7.barcodescanner.zxing.ZXingScannerView;
import main.java.me.dm7.barcodescanner.zxing.ZXingScannerView.ResultHandler;
import main.java.me.dm7.barcodescanner.core.ViewFinderView;

import main.java.me.dm7.barcodescanner.core.BarcodeScannerView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
//import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;

import anywheresoftware.b4a.BA.Events;
//import android.view.MotionEvent;

//import android.graphics.Color;
//import android.graphics.Typeface;

import android.view.View;
//import android.view.Gravity; 

//import android.util.Log;
//import android.view.ViewTreeObserver;

//import android.media.AudioFormat;
//import android.media.AudioRecord;
//import android.media.MediaRecorder;

import java.util.ArrayList;
import java.util.List;
//import java.util.Timer;
//import java.util.TimerTask;

//import android.os.Build;
//import android.os.Bundle;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.Result;
import android.support.v4.app.DialogFragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.view.MenuItemCompat;
import android.view.Menu;
import android.view.MenuItem;

import android.media.ToneGenerator;
import android.media.AudioManager;

import android.media.Ringtone;
import android.media.RingtoneManager;
import android.net.Uri;

@ActivityObject
@Events(values={"scan_result(scantext As String, scanformat As String)", "brightness_changed(bright As Int)"})
@Author("Github: Dushyanth Maguluru, Wrapped by: Johan Schoeman")
@Permissions(values={"android.permission.CAMERA", "android.permission.FLASHLIGHT"})
@Version(1.03f)
@ShortName("ZxingBarcodeScanner")
@DependsOn(values={"core-3.2.1", "com.android.support:support-v4"})
public class zxingBarcodeScannerWrapper extends ViewWrapper<ZXingScannerView> implements DesignerCustomView, ZXingScannerView.ResultHandler    {


	private BA ba;
	private String eventName;
    private ZXingScannerView cv;
	
	private static final String FLASH_STATE = "FLASH_STATE";
    private static final String AUTO_FOCUS_STATE = "AUTO_FOCUS_STATE";
    private static final String SELECTED_FORMATS = "SELECTED_FORMATS";
    private static final String CAMERA_ID = "CAMERA_ID";
    private boolean mFlash;
    private boolean mAutoFocus;
    private ArrayList<Integer> mSelectedIndices;
    private int mCameraId = -1;
	private ViewFinderView vfv;
	@Hide
	public static int autoFocusInterval = 1000;
	
	@Hide
	public static String FocusMode = "FOCUS_MODE_CONTINUOUS_VIDEO";
	
	public String FOCUS_MODE_AUTO = "FOCUS_MODE_AUTO";
	public String FOCUS_MODE_CONTINUOUS_PICTURE = "FOCUS_MODE_CONTINUOUS_PICTURE";
    public String FOCUS_MODE_CONTINUOUS_VIDEO = "FOCUS_MODE_CONTINUOUS_VIDEO";	
    public String FOCUS_MODE_MACRO = "FOCUS_MODE_MACRO";		
    //public String FOCUS_MODE_EDOF = "FOCUS_MODE_EDOF";	
    //public String FOCUS_MODE_FIXED = "FOCUS_MODE_FIXED";
    public String FOCUS_MODE_INFINITY = "FOCUS_MODE_INFINITY";		
	

	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new ZXingScannerView(ba.context);
        this.setObject(cv);

        addListener2();
		addListener3();
		addListener();
 	}

 //    private void addListener() {
 
 //    }





//     private void addListener() {
//        cv.setOnProgressTrackListener(new OnProgressTrackListener() {
//            @Override
//            public void onProgressFinish() {
//              if (ba.subExists(eventName + "_progress_completed")) {
//                ba.raiseEvent2(ba, false, eventName + "_progress_completed", true, new Object[0]);
//              }
//            }
//            @Override
//            public void onProgressUpdate(int progress) {
//              if (ba.subExists(eventName + "_progress_changed")) {
//                ba.raiseEvent2(ba, false, eventName + "_progress_changed", true, new Object[]{progress});
//              }
//            }
//        });
//    }



//          public void addListener2() {
//            ViewTreeObserver observer = cv.getViewTreeObserver();
//            observer.addOnGlobalLayoutListener(new ViewTreeObserver.OnGlobalLayoutListener() {
//                @Override
//                public void onGlobalLayout() {
//                    cv.setBaseY(cv.getHeight());
//                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN) {
//                        cv.getViewTreeObserver().removeOnGlobalLayoutListener(this);
//                    } else {
//                        cv.getViewTreeObserver().removeGlobalOnLayoutListener(this);
//                    }
//                }
//            });
//          }




    @Hide
    private void addListener(){

        cv.setCallback(new BarcodeScannerView.Callback() {
            @Override
            public void ambient_light_changed() {

              if (ba.subExists(eventName + "_ambient_light_changed")) {
                ba.raiseEvent2(ba, false, eventName + "_ambient_light_changed", true, new Object[]{cv.getAmbientLightLux()});
              }
            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_click")) {
//                ba.raiseEvent2(ba, false, eventName + "_click", true, new Object[0]);
//              }
//            }


        });
    }
	
	
    @Hide
    public void addListener3(){

        cv.setCallback(new ZXingScannerView.Callback() {
            @Override
            public void brightness_changed() {

              if (ba.subExists(eventName + "_brightness_changed")) {
                //ba.raiseEvent2(ba, false, eventName + "_brightness_changed", true, new Object[]{cv.getBrightness()});
				ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_brightness_changed", true, new Object[]{cv.getBrightness()});

              }
            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_click")) {
//                ba.raiseEvent2(ba, false, eventName + "_click", true, new Object[0]);
//              }
//            }


        });
    }
	


      @Hide
      public void addListener2(){
        cv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                toggleFlash();
            }
        });
      }

//    public void addImage(String draw) {
//		 int DrawableID = BA.applicationContext.getResources().getIdentifier(draw, "drawable", BA.packageName);
//               cv.setForeground(DrawableID);
//		 Drawable drawable = BA.applicationContext.getResources().getDrawable(DrawableID);
//                 cv.setForeground(drawable); 
//    }


	
	//programmatically add view
    @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

    @Override
	@Hide
    public void handleResult(Result rawResult) {
        // Do something with the result here
		String returntext = "";
		String returnformat = "";
        returntext = "" + rawResult.getText(); // Prints scan results
        returnformat = "" + rawResult.getBarcodeFormat().toString(); // Prints the scan format (qrcode, pdf417 etc.)
        if (ba.subExists(eventName + "_scan_result")) {
          //ba.raiseEvent2(ba, false, eventName + "_scan_result", true, new Object[] {returntext, returnformat});
		  ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_scan_result", true, new Object[]{returntext, returnformat});


//        try {
//            Uri notification = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
//            Ringtone r = RingtoneManager.getRingtone(ba.context, notification);
//            r.play();
//        } catch (Exception e) {}


          //final ToneGenerator tg = new ToneGenerator(AudioManager.STREAM_NOTIFICATION, 100);
          //tg.startTone(ToneGenerator.TONE_PROP_PROMPT);		  
        }
        // If you would like to resume scanning, call this method below:
        cv.resumeCameraPreview(this);
		if (flashOn == true) cv.setFlash(true);
    }
	
	/**
     * Start the barcode scanner
     */		
    public void startScanner() {
        flashOn = false;
        cv.setResultHandler(this); // Register ourselves as a handler for scan results.
        cv.setAutoFocus(state);	
        cv.startCamera();          // Start camera on resume
		cv.startAmbientSensor();
		
    }

	/**
     * Stop the barcode scanner
     */	 
    public void stopScanner() {
		flashOn = false;
        cv.stopAmbientSensor();
		cv.setFlash(false);
        cv.stopCamera();           // Stop camera on pause
    }
	
	
	@Hide
	public static int laserColor = 0xffff0000;
    public void setLaserColor(int laserColor) { 
         this.laserColor = laserColor;
    }
	
	@Hide
	public static int maskColor = 0x88ff0000;
    public void setMaskColor(int maskColor) {
        this.maskColor = maskColor;
    }
	
	@Hide
	public static int borderColor = 0xff00ff00;	
    public void setBorderColor(int borderColor) {
        this.borderColor = borderColor;
    }

	@Hide
	public static int borderStrokeWidth = 2;		
    public void setBorderStrokeWidth(int borderStrokeWidth) {
        this.borderStrokeWidth = borderStrokeWidth;
    }
	
	@Hide
	public static int borderLineLength = 15;		
    public void setBorderLineLength(int borderLineLength) {
        this.borderLineLength = borderLineLength;
    }
	
	@Hide
	public static boolean flashOn = false;
    /**
     * Toggle the Torch between ON and OFF
     */	 	
	public void toggleFlash() {
		if (flashOn == false) {
		  flashOn = true;
	      cv.setFlash(true);
		}  else {
		  flashOn = false;
	      cv.setFlash(false);			
		}
    }
	

     /**
     * Turn the torch / flash On
     */	 	
    public void TurnFlashOn() {
		  flashOn = true;
	      cv.setFlash(true);
    }	 
	

     /**
     * Turn the torch / flash Off
     */	 		
 	public void TurnFlashOff() {
		  flashOn = false;
	      cv.setFlash(false);
    }	


     /**
     * Check if the torch / flash is On or Off
     */	 	
	public boolean isFlashOn () {
		return flashOn;
	}	
	
     /**
     * Get the current Lux value
     */	 
     private float getAmbientLightLux()	{
	    return cv.getAmbientLightLux();
    }


    /**
     * Switch ON the torch if the Lux value is lower than this
     */	
     private void setLowerLuxLimit(float LowerLuxLimit) {
		cv.setLowerLuxLimit(LowerLuxLimit);
	} 
	
    /**
     * Switch OFF the torch if the Lux value is lower than this
     */		
     private void setUpperLuxLimit(float UpperLuxLimit) {
		cv.setLowerLuxLimit(UpperLuxLimit);
	}	 
	

    /**
     * Set control of the Torch based on values from the light sensor
     */		
     private void setAutoTorchModeLux(boolean AutoTorchMode) {
		cv.setAutoTorchMode(AutoTorchMode);
	}	 

    /**
     * Get the average brightness of the last frame that has been captured for possible barcode extraction
     */		
	public int getBrightness() {
		return cv.getBrightness();
	}	
	
	private boolean BrightTorchMode = false;
    /**
     * Set control of the Torch based on brightness of the frame captured
     */		
     private void setAutoTorchModeBrightness(boolean BrightTorchMode) {
		this.BrightTorchMode = BrightTorchMode;
	}	 

    /**
     * Set the auto focus interval
	 * The default value is 1000ms
     */			
	public void setAutoFocusInterval(int autoFocusInterval) {
		this.autoFocusInterval = autoFocusInterval;
	}
	
    /**
     * Set the focus mode to use. It can be one of the following:
     * FOCUS_MODE_AUTO, FOCUS_MODE_CONTINUOUS_PICTURE, FOCUS_MODE_CONTINUOUS_VIDEO, FOCUS_MODE_MACRO, FOCUS_MODE_INFINITY	 
	 * The default value is FOCUS_MODE_CONTINUOUS_VIDEO
     */			
	public void setFocusMode(String FocusMode) {
         this.FocusMode = FocusMode;
    }
	
	private boolean state = true;
	public void setAutoFocus(boolean state) {
	      this.state = state;
    }	
	
	public void zoomIn(int zoomValue) {
	  cv.zoomIn(zoomValue);
	}	
	
	public int getCurrentZoomValue() {
	  return cv.getCurrentZoomValue();
	}	

	public int getMaxZoomValue() {
		return cv.getMaxZoomValue();
	}	
	
	
}
